/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Tomer Gidron
 *
 */

#include "TotFlagsHUD.h"

#include "core/CoreIncludes.h"
#include "core/XMLPort.h"
#include "util/Convert.h"

namespace orxonox
{
    RegisterClass(TotFlagsHUD);

    TotFlagsHUD::TotFlagsHUD(Context* context) : OverlayText(context)
    {
        RegisterObject(TotFlagsHUD);

        this->hoverGame_ = nullptr;
        this->totFlags_ = 0;
    }

    void TotFlagsHUD::XMLPort(Element& xmlelement, XMLPort::Mode mode)
    {
        SUPER(TotFlagsHUD, XMLPort, xmlelement, mode);

        XMLPortParam(TotFlagsHUD,"showPoints", setShowTot, getShowTot, xmlelement, mode);
    }

    void TotFlagsHUD::tick(float dt)
    {
        SUPER(TotFlagsHUD, tick, dt);

            const std::string& points = multi_cast<std::string>(this->DodgeRaceGame->getPoints());
                setTextSize(0.04);
                setPosition(Vector2(0.14, 0.02));
                this->setColour(ColourValue(1, 1, 1, 1));
                this->setCaption(points);
            
    }

    void TotFlagsHUD::changedOwner()
    {
        SUPER(TotFlagsHUD, changedOwner);

        if (this->getOwner() && this->getOwner()->getGametype())
        {
            this->TotFlagsHUD = orxonox_cast<Hover*>(this->getOwner()->getGametype());
        }
        else
        {
            this->DodgeRaceGame = nullptr;
        }
    }
}
